struct sm_list {
        struct sm_list *next;
};

#define sm_container_of(p, t, n) \
        ((t *)((char *)p - offsetof(t, n)))

inline struct sm_list *sm_list_next(struct sm_list *x) {
        assert(x);
        return x->next;
}

inline void sm_list_insert(struct sm_list *x, struct sm_list *y) {
        assert(x); assert(y); assert(y->next == NULL);
        y->next = x->next;
        x->next = y;
}

inline struct sm_list *sm_list_tail(struct sm_list *x) {
        assert(x);
        while (x && x->next) { x = x->next; }
        return x;
}


#define SM_DEFINE_LIST(pfx, holdtype, field) \
        inline struct sm_list * pfx ## _iter(holdtype *val) { assert(val); return &val->field; } \
        inline holdtype * pfx ## _value(struct sm_list *x) { \
                assert(x); \
                return sm_container_of(x, holdtype, field); \
        } \
        inline void pfx ## _insert(struct sm_list *x, holdtype *val) { \
                assert(val); \
                sm_list_insert(x, &val->field); \
        } \
        inline void pfx ## _append(struct sm_list *x, holdtype *val) { \
                assert(x); assert(val); \
                pfx ## _insert(sm_list_tail(x), val); \
        }



struct foo {
        int a;
        struct sm_list bar_list;
}

SM_DEFINE_LIST(foo_bar, struct foo, bar_list);
