#pragma once
#include <stdint.h>


static inline uint8_t be8toh(uint8_t x) { return x; }

#define htobe8(x) be8toh(x)

static inline uint8_t le8toh(uint8_t x) { return x; }

#define htole8(x) le8toh(x)


#ifdef UINT16_C

static inline uint16_t be16toh(uint16_t x)
{
	const uint8_t *np = (uint8_t *)&x;
	return (np[0] << 8) | np[1];
}

#define htobe16(x) be16toh(x)

static inline uint16_t le16toh(uint16_t x)
{
	const uint8_t *np = (uint8_t *)&x;
	return (np[1] << 8) | np[0];
}

#define htole16(x) le16toh(x)


#ifdef UINT32_C

static inline uint32_t be32toh(uint32_t x)
{
	const uint16_t *np = (uint16_t *)&x;
	return ((uint32_t)be16toh(np[0]) << 16) | be16toh(np[1]);
}

#define htobe32(x) be32toh(x)

static inline uint32_t le32toh(uint32_t x)
{
	const uint16_t *np = (uint16_t *)&x;
	return ((uint32_t)le16toh(np[1]) << 16) | le16toh(np[0]);
}

#define htole32(x) le32toh(x)


#ifdef UINT64_C

static inline uint64_t be64toh(uint64_t x)
{
	const uint32_t *np = (uint32_t *)&x;
	return ((uint64_t)be32toh(np[0]) << 32) | be32toh(np[1]);
}

#define htobe64(x) be64toh(x)

static inline uint64_t le64toh(uint64_t x)
{
	const uint32_t *np = (uint32_t *)&x;
	return ((uint64_t)le32toh(np[1]) << 32) | le16toh(np[0]);
}

#define htole64(x) le64toh(x)

#endif /* UINT64_C */

#endif /* UINT32_C */

#endif /* UINT16_C */
